﻿<?php
$upl = -1;

function agv($array, $key, $default = NULL) {
  return isset($array[$key]) ? $array[$key]: $default;
}

if(agv($_FILES, 'fname')) {
  if(is_uploaded_file($_FILES['fname']['tmp_name'])) {
    move_uploaded_file($_FILES['fname']['tmp_name'], './models/tmp.vrm' );
    $upl = 1;
  } 
}
?>

<!DOCTYPE html>

<html>
	<head>
		<meta charset="utf-8" />
		<title> - VRM　ロードテスト - </title>
		<meta
			name="viewport"
			content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no"
		/>
		<style>
			body {
				margin: 0;
			}
			canvas {
				display: block;
			}
		</style>
	</head>

	<body>
		<div id="info">
			<a href="http://nas6.net/index.htm">ＮＡＳ６ネバーランド</a> - VRM　ロードテスト - 
		</div>
<form enctype="multipart/form-data" method="POST">
		<div id="labels" class="menu">
			Load VRM file<br/><br/>
			<input type="file" name="fname">
			<input type="submit" value="アップロード">
		</div>
</form>


		<script src="https://unpkg.com/three@0.132.2/build/three.js"></script>
		<script src="https://unpkg.com/three@0.132.2/examples/js/loaders/GLTFLoader.js"></script>
		<script src="https://unpkg.com/three@0.132.2/examples/js/controls/OrbitControls.js"></script>
		<script src="../lib/three-vrm.js"></script>
		<script>
			var path = './models/てす子制服.vrm';
			var ul = <?php echo $upl; ?>;
			if(0 < ul){
				path = './models/tmp.vrm'
			}
			// renderer
			const renderer = new THREE.WebGLRenderer();
			renderer.setSize( window.innerWidth, window.innerHeight );
			renderer.setPixelRatio( window.devicePixelRatio );
			document.body.appendChild( renderer.domElement );

			// camera
			const camera = new THREE.PerspectiveCamera( 30.0, window.innerWidth / window.innerHeight, 0.1, 20.0 );
			camera.position.set( 0.0, 1.0, 5.0 );

			// camera controls
			const controls = new THREE.OrbitControls( camera, renderer.domElement );
			controls.screenSpacePanning = true;
			controls.target.set( 0.0, 1.0, 0.0 );
			controls.update();

			// scene
			const scene = new THREE.Scene();

			// light
			const light = new THREE.DirectionalLight( 0xffffff );
			light.position.set( 1.0, 1.0, 1.0 ).normalize();
			scene.add( light );

			// gltf and vrm
			const loader = new THREE.GLTFLoader();
			loader.crossOrigin = 'anonymous';
			loader.load(

				// URL of the VRM you want to load
				path,

				// called when the resource is loaded
				( gltf ) => {

					// calling this function greatly improves the performance
					THREE.VRMUtils.removeUnnecessaryJoints( gltf.scene );

					// generate VRM instance from gltf
					THREE.VRM.from( gltf ).then( ( vrm ) => {

						console.log( vrm );
						scene.add( vrm.scene );

						vrm.humanoid.getBoneNode( THREE.VRMSchema.HumanoidBoneName.Hips ).rotation.y = Math.PI;

					} );

				},

				// called while loading is progressing
				( progress ) => console.log( 'Loading model...', 100.0 * ( progress.loaded / progress.total ), '%' ),

				// called when loading has errors
				( error ) => console.error( error )

			);
			// helpers
			const gridHelper = new THREE.GridHelper( 10, 10 );
			scene.add( gridHelper );

			const axesHelper = new THREE.AxesHelper( 5 );
			scene.add( axesHelper );

			function animate() {

				requestAnimationFrame( animate );

				renderer.render( scene, camera );

			}

			animate();
		</script>
	</body>
</html>

